
IMPLEMENTATION  MODULE  edshow;


PROCEDURE       BlockSeiteAusgeben ( a,b: position ); FORWARD;

PROCEDURE       AuschnittErmitteln ( a,b: position;  VAR c,d: position );FORWARD;
PROCEDURE       ABZeileAusgeben ( a,b: position ); FORWARD;
PROCEDURE       AZeileAusgeben  ( a: position;i:CARDINAL ); FORWARD;
PROCEDURE       BZeileAusgeben  ( b: position;i:CARDINAL  ); FORWARD;
PROCEDURE       LinksOben       ( a,b: position; VAR c:position ); FORWARD;
PROCEDURE       RechtsUnten     ( a,b: position; VAR c:position ); FORWARD;




PROCEDURE    CursorSetzen;
BEGIN       Window.GotoXY (x-LinkerRand, y+1 );  END CursorSetzen;



PROCEDURE    VirtuelleZeile ( p:  pzeile; a : ADDRESS  );
VAR     i:  CARDINAL;
BEGIN
IF      (p = NIL ) OR (p^.h <= LinkerRand )    THEN  i:=0; ELSE i:= p^.h-LinkerRand END;
IF      i > WindowSpalten     THEN  i:= WindowSpalten END;
(*  0<= i <= WindowSpalten gibt die anzahl der "echten" zeichen ab LinkerRand an *)
IF      i> 0                  THEN   Move( ADR (p^.q^[LinkerRand]), a, i          )  END;
Lib.IncAddr(a,i);
IF      i< WindowSpalten      THEN   Move( ADR (leerzeile), a, WindowSpalten -i )  END;
END     VirtuelleZeile;





PROCEDURE    ZeileAusgeben( t:  pzeile; y:  CARDINAL);
VAR     i,h:  CARDINAL;  s: string;
BEGIN
INC ( y ); VirtuelleZeile (t,ADR(s));
DirectWrite (1,y, ADR (s), WindowSpalten);
END     ZeileAusgeben;




PROCEDURE    ZeilenAusgeben  ( i,j: CARDINAL;  t: pzeile );
VAR     k:   CARDINAL;
BEGIN   IF       i> j   THEN RETURN END;
FOR     k:= i TO j   DO
	ZeileAusgeben (t, k);   IF t <> NIL  THEN   t:= t^.n  END;
END;
END     ZeilenAusgeben;






PROCEDURE    SeiteAusgeben ;
VAR     t: pzeile;  i:  CARDINAL;
BEGIN
Abspeichern ;
ScreenTox;
ysaved:= y;  zsaved:= z;
ZeileAusgeben (p, y );
ZeilenAusgeben(1, WindowZeilen, top () );
END     SeiteAusgeben;




PROCEDURE    Invers;
VAR     w: Window.WinType;
BEGIN
w := Window.Top();
IF      w^.WDef.Foreground = Window.Black  THEN
        w^.WDef.Foreground:= Window.White; w^.WDef.Background :=Window.Black;
ELSE    w^.WDef.Foreground:= Window.Black; w^.WDef.Background :=Window.LightGray;
END;
END     Invers;








PROCEDURE    QuickShow;
BEGIN   IF  xInScreen()   THEN Abspeichern; ZeileAusgeben ( p, y)   END;
END     QuickShow;



PROCEDURE    ModusAusgeben;
VAR     i:  CARDINAL; s : ARRAY [0..Window.ScreenWidth] OF CHAR;
BEGIN
IF   Einfuegemodus  THEN
     Window.SetTitle (Window.Top(),"Insert",Window.RightUpperTitle)
ELSE Window.SetTitle (Window.Top(),"Override",Window.RightLowerTitle) END;
END     ModusAusgeben;




PROCEDURE    HinweisAusgeben ( m:  ARRAY OF CHAR    );
VAR     i:  CARDINAL; s : ARRAY [0..Window.ScreenWidth] OF CHAR;
BEGIN
i:=  min ( HIGH(m),WindowSpalten DIV 2);
Window.DirectWrite (WindowSpalten-i+1,1, ADR(m),i);
END     HinweisAusgeben;




PROCEDURE    Statuszeile;
VAR
sx,sz,sSpalten:  ARRAY [0..5] OF  CHAR;
m: string;
ok:  BOOLEAN;
j : CARDINAL;
BEGIN
Str.CardToStr(LONGCARD (x),       sx ,10,ok);
Str.CardToStr(LONGCARD (Spalten), sSpalten,10,ok);
Str.CardToStr(LONGCARD (z),       sz ,10,ok);
Concat(m,"Zeile/Spalte/Eingabegrenze:", sz);
Concat(m,m,"/"); Concat(m,m,sx);Concat(m,m,"/"); Concat(m,m,sSpalten);

j:= min(Length(m) ,WindowSpalten);
Window.DirectWrite (1,1, ADR(m),j);
IF  j < WindowSpalten  THEN
    Window.DirectWrite(j+1,1,ADR(leerzeile),WindowSpalten-j)
END;
ModusAusgeben;
END     Statuszeile;




PROCEDURE    Ausgabe    ;
BEGIN
Statuszeile;
IF      NOT xInScreen() OR  TopChanged()     THEN SeiteAusgeben END;
saveyz; CursorSetzen;
END     Ausgabe;






PROCEDURE    BlockSeiteAusgeben ( a1,b1: position );
VAR     a,b: position;  t: pzeile;  i:CARDINAL;
BEGIN   test (p = b1.p,"BlockSeiteAusgeben");
Statuszeile; ScreenTox; t := top ();  Abspeichern;
AuschnittErmitteln(a1,b1,a,b);
i:=1;
WHILE t<>a.p   DO  ZeileAusgeben(t,i);  INC(i); t:=t^.n;  END;
IF      a.p = b.p     THEN  ABZeileAusgeben (a, b ); INC(i); t:=t^.n;
ELSE    AZeileAusgeben (a, i);  INC(i); t:=t^.n;
	Invers;   WHILE t<> b.p DO ZeileAusgeben (t,i); INC(i); t:=t^.n  END;
	Invers;   BZeileAusgeben (b, i); INC(i); t:=t^.n;
END;
ZeilenAusgeben( i, WindowZeilen,  t );
saveyz;
CursorSetzen;
END     BlockSeiteAusgeben;





PROCEDURE    AZeileAusgeben ( a: position; iy:CARDINAL);
VAR     p : pzeile;  x,y,k,i,h: CARDINAL;
	s : string;
BEGIN   p := a.p;   x:= a.x;   y := iy;
IF      x> LinkerRand + WindowSpalten THEN  ZeileAusgeben  (p,y);  RETURN; END;
IF      x<=LinkerRand           THEN  Invers; ZeileAusgeben  (p,y);  Invers; RETURN; END;
(*  x ist InScreen ===>  virtuelle zeile aufbauen  *)
INC(y); VirtuelleZeile(p, ADR(s));
i:= x-LinkerRand;
IF      i> 1   THEN     DirectWrite (1,y,    ADR(s[0]  ), i-1 );  END;
Invers ;                DirectWrite (i,y,    ADR(s[i-1]), WindowSpalten-i+1 );
Invers;
END     AZeileAusgeben;






PROCEDURE    BZeileAusgeben ( b: position; iy: CARDINAL);
VAR     p : pzeile;  x,y,k,i,h: CARDINAL;
	s : string;
BEGIN   p := b.p;   x:= b.x;   y := iy;
IF      x> LinkerRand + WindowSpalten THEN  Invers; ZeileAusgeben  (p,y);Invers;  RETURN; END;
IF      x<=LinkerRand           THEN  ZeileAusgeben  (p,y);  RETURN; END;
(*  x ist InScreen ===>  virtuelle zeile aufbauen  *)
INC(y); VirtuelleZeile(p, ADR(s));
i:= x-LinkerRand;  Invers;      DirectWrite (1  ,y,   ADR(s[0]  ), i );   Invers;
IF   i < WindowSpalten THEN   DirectWrite (1+i,y,   ADR(s[i])  , WindowSpalten-i);
END;
END     BZeileAusgeben;





PROCEDURE    ABZeileAusgeben ( a,b: position);
VAR     p : pzeile;  x,y,k,i,ai,bi,h: CARDINAL;
	s : string;
	aInScreen, bInScreen: BOOLEAN;
BEGIN   p := b.p;   x:= b.x;   y := b.y;
aInScreen  := (LinkerRand < a.x )  AND ( a.x <= LinkerRand + WindowSpalten );
bInScreen  := (LinkerRand < b.x )  AND ( b.x <= LinkerRand + WindowSpalten );
IF      NOT aInScreen   THEN  BZeileAusgeben ( b, y);
ELSIF   NOT bInScreen   THEN  AZeileAusgeben ( a, y);
ELSE
INC(y); VirtuelleZeile(p, ADR(s));  ai := a.x - LinkerRand;  bi := b.x-LinkerRand ;
IF   ai  >  1    THEN   DirectWrite (1   ,y ,   ADR(s[0])    , ai-1    );
END;
Invers;                 DirectWrite (ai  ,y ,   ADR(s[ai-1]) , bi-ai +1);
Invers;
IF  bi < WindowSpalten THEN
                        DirectWrite (bi+1,y ,   ADR(s[bi]) , WindowSpalten-bi);
END;
END; (* ELSE *)
END     ABZeileAusgeben;






PROCEDURE    AuschnittErmitteln ( a,b: position;  VAR aa,bb: position );
VAR     o,u: position;
BEGIN   (* b.p ist aktiv *)
LinksOben (a,b,o);  RechtsUnten (a,b,u);
test ( (o.z <= b.z ) AND ( b.z <= u.z ), "AuschnittErmitteln");
aa := a;
IF      a.z <  o.z    THEN  aa := o;  END;
IF      a.z >  u.z    THEN  aa := u;  END;
bb := b;  (* aa und bb sind nun auf dem Bildschirm *)
PositionenSortieren (aa,bb);
END     AuschnittErmitteln;



PROCEDURE    LinksOben ( a,b: position;  VAR c: position);
BEGIN   (* b.p ist aktiv *)
c.p := top();  c.z := z-y+1 ;  c.y := 1; c.x := 1;
END     LinksOben;




PROCEDURE    RechtsUnten  ( a,b: position;  VAR c: position);
BEGIN   (* b.p ist aktiv *)
c.p := p; c.y := y ; c.z := z; c.x := LinkerRand+ WindowSpalten;
(*c.x  ist nur fr die anzeige relevant. fr die operation werden dann
die echten blockmarken verwendet *)
WHILE ( c.p^.n <> NIL )  AND   ( c.y   < WindowZeilen )  DO
	c.p := c.p^.n;  INC (c.z);  INC(c.y );
END;
END     RechtsUnten;


BEGIN
END     edshow.

