MODULE  edtest;

FROM    RdComand        IMPORT  befehle, RdCom;
FROM    ed              IMPORT
        string,string1,pstring,pzeile,zeile,position,
        Spalten,WindowZeilen,WindowSpalten,WindowZeilenGesamt,
        WindowSpaltenGesamt, Fehlerkontext, x,y,z,linkerrand,
        ysaved,zsaved, p,anfang,ablage, s, leerzeile, empty,
        FensterDef,Fenster;
FROM    Window          IMPORT  DirectWrite;
FROM    Lib             IMPORT  Move;
FROM    Storage         IMPORT  ALLOCATE, DEALLOCATE;
FROM    Str             IMPORT  Copy,Insert, Delete,Length,Concat, Slice;
IMPORT  Str,Storage,Window,Lib,IO;

CONST
MaxSpalten  =  1000;

TYPE
befehlsmenge = SET OF befehle;
zeichen      = SET OF CHAR;

VAR

taste           :  string1;
key             :  CHAR;
Einfuegemodus   :  BOOLEAN;
CursorVeraendern:  befehlsmenge;
AktiveBefehle   :  befehlsmenge;
BlockOptions,ControlKOptions,ControlQOptions    :  zeichen;
comand             :  befehle;
alphanumerisch  :  zeichen;

PROCEDURE       seiteausgeben   ; FORWARD;
PROCEDURE       zeilenausgeben ( i,j: CARDINAL; t: pzeile); FORWARD;
PROCEDURE       ausgeben (t: pzeile; i: CARDINAL); FORWARD;
PROCEDURE       quickshow     ; FORWARD;
PROCEDURE       test  ( bedingung: BOOLEAN; meldung:  ARRAY OF CHAR);FORWARD;
PROCEDURE       fehler  (  meldung:  ARRAY OF CHAR);FORWARD;
PROCEDURE       piepsen(i: CARDINAL)       ; FORWARD;
PROCEDURE       Invers        ; FORWARD;
PROCEDURE       zeilenumbruch ; FORWARD;
PROCEDURE       top (): pzeile; FORWARD;
PROCEDURE       nextwordchar  ; FORWARD;
PROCEDURE       FirstOfPrevWord;FORWARD;
PROCEDURE       xInScreen (): BOOLEAN; FORWARD;
PROCEDURE       ScreenTox ;  FORWARD;
PROCEDURE       abspeichern; FORWARD;
PROCEDURE       virtuellezeile (p: pzeile; a: ADDRESS); FORWARD;
PROCEDURE       speichern ( p: pzeile; VAR s: ARRAY OF CHAR ); FORWARD;
PROCEDURE       laden; FORWARD;
PROCEDURE       skipblanks ( p: pstring; i: CARDINAL;
                VAR j: CARDINAL ); FORWARD;
PROCEDURE       verkettenmoeglich(): BOOLEAN; FORWARD;
PROCEDURE       Blockoperation;  FORWARD;
PROCEDURE       capkey (): CHAR ;   FORWARD;
PROCEDURE       Blocksatz; FORWARD;
PROCEDURE       positionmerken ( VAR  a: position ); FORWARD;
PROCEDURE       blockanzeigen ( a,b: position ); FORWARD;
PROCEDURE       sortieren ( VAR a,b: position ); FORWARD;
PROCEDURE       ausschnitt ( a,b: position;  VAR c,d: position );FORWARD;
PROCEDURE       abzeileanzeigen ( a,b: position ); FORWARD;
PROCEDURE       azeileanzeigen  ( a: position ); FORWARD;
PROCEDURE       bzeileanzeigen  ( b: position ); FORWARD;
PROCEDURE       blockdefinieren ( VAR a,b: position ); FORWARD;
PROCEDURE       blockloeschen   ( VAR a,b: position ); FORWARD;
PROCEDURE       blocknachlinks  ( VAR a,b: position ); FORWARD;
PROCEDURE       blocknachrechts ( VAR a,b: position ); FORWARD;
PROCEDURE       linksoben       ( a,b: position; VAR c:position ); FORWARD;
PROCEDURE       rechtsunten     ( a,b: position; VAR c:position ); FORWARD;
PROCEDURE       nextblank       ( p: pstring; i: CARDINAL;  VAR j:
                                CARDINAL); FORWARD;
PROCEDURE       blankseinstreuen   ( p: pstring );  FORWARD;

PROCEDURE       min ( i,j: CARDINAL ):  CARDINAL;
BEGIN           IF  i <= j  THEN RETURN i ; ELSE RETURN j;  END;
END   min;

PROCEDURE       max ( i,j: CARDINAL ):  CARDINAL;
BEGIN           IF  i <= j  THEN RETURN j ; ELSE RETURN i;  END;
END   max;

PROCEDURE    seiteausgeben ;
VAR     t: pzeile;  i:  CARDINAL;
BEGIN
ScreenTox;  t:= top(); abspeichern ;
ausgeben (p, y ); zeilenausgeben(1, WindowZeilen, top () );
END     seiteausgeben;

PROCEDURE    zeilenausgeben  ( i,j: CARDINAL;  t: pzeile );
VAR     k:   CARDINAL;
BEGIN   IF       i> j   THEN RETURN END;
FOR     k:= i TO j   DO
        ausgeben (t, k);   IF t <> NIL  THEN   t:= t^.n  END;
END;
END     zeilenausgeben;

PROCEDURE    ausgeben( t:  pzeile; y:  CARDINAL);
VAR     i,h:  CARDINAL;  s: string;
BEGIN
INC ( y ); virtuellezeile (p,ADR(s));
DirectWrite (1,y, ADR (s), WindowSpalten);
END     ausgeben;

PROCEDURE    virtuellezeile ( p:  pzeile; a : ADDRESS  );
VAR     i:  CARDINAL;
BEGIN
IF      (p = NIL ) OR (p^.h <= linkerrand )
  THEN  i:=0; ELSE i:= p^.h-linkerrand END;
IF      i > WindowSpalten     THEN  i:= WindowSpalten END;
(*  0<= i <= WindowSpalten gibt die anzahl der "echten"
 zeichen ab linkerrand an *)
IF      i> 0
  THEN   Move( ADR (p^.q^[linkerrand]), a, i          )  END;
IF      i< WindowSpalten
  THEN   Move( ADR (leerzeile), a, WindowSpalten -i )  END;
END     virtuellezeile;

PROCEDURE    Invers;
VAR     c: Window.Color;
BEGIN   c:=FensterDef.Foreground ;
FensterDef.Foreground  := FensterDef.Background;
FensterDef.Background  := c;
END     Invers;

PROCEDURE    quickshow;
BEGIN   IF  xInScreen()   THEN ausgeben ( p, y)   END;
END     quickshow;

PROCEDURE    piepsen(HelptextNummer:  CARDINAL);
BEGIN        Fehlerkontext := HelptextNummer;
             (* bell,"PRESS ENTER FOR HELP"  *)
END  piepsen;

PROCEDURE    HelpHinweis;
BEGIN        Window.GotoXY(1,1);  IO.WrStr("PRESS F1 capkey() FOR HELP");
END          HelpHinweis;

PROCEDURE       test ( bedingung: BOOLEAN ; meldung: ARRAY OF CHAR );
BEGIN   IF      bedingung = FALSE  THEN  fehler(meldung)  END;
END             test;

PROCEDURE    fehler ( meldung: ARRAY OF  CHAR );
BEGIN        Window.GotoXY(1,WindowZeilen +1);
IO.WrStr("FEHLER: "); IO.WrStr(meldung); HALT;
END          fehler;

PROCEDURE    top(): pzeile;
VAR     i: INTEGER;   t: pzeile;
BEGIN   t:= p;
FOR     i:= 1    TO  y-1  DO  t:=t^.v; test (t <> NIL, "top"); END;
RETURN  t;
END     top;

PROCEDURE    saveyz;
BEGIN   ysaved:=  y; zsaved:= z;        END saveyz;

PROCEDURE    topchanged():  BOOLEAN;
(* top kann nicht anhand eines gesicherten zeigers identifiziert werden*)
BEGIN   RETURN  ( zsaved -ysaved )  <>  ( z -y  );  (* Diff. sind >=0 *)
END     topchanged;

PROCEDURE    kuerzen;
VAR     h: CARDINAL;
BEGIN   (* alle leerzeichen am rechten ende werden entfernt *)
h:= Length( s); IF  h = 0    THEN RETURN END;
WHILE ( h>0  ) AND ( s[h-1] = ' ') DO    DEC(h)  END;  s[h] := 0C;
END kuerzen;

PROCEDURE    randbreite(): CARDINAL;
VAR     i: CARDINAL;
BEGIN   i:= 0;  WHILE s[i] = ' '  DO  INC(i)  END;
RETURN min (i, x-1);
END randbreite;

PROCEDURE    auffuellen;
VAR     h,k: CARDINAL;
BEGIN   test ( x <= MaxSpalten +1, " auffuellen ");
h:= Length( s); IF  h>= x-1  THEN RETURN END;
WHILE ( h< x-1)  DO s[h] := ' ';INC(h)  END;   s[h] := 0C;
END auffuellen;

PROCEDURE    decx;
BEGIN   IF   x  > 1  THEN DEC(x)   END; END decx;

PROCEDURE    incx;
BEGIN   IF   x  <= Spalten  THEN INC(x)   END; END incx;

PROCEDURE    decp;
BEGIN   IF  p^.v = NIL   THEN RETURN END;
p:=  p^.v; DEC(z);  IF  y> 1  THEN DEC(y)  END;
END decp;

PROCEDURE    incp;
BEGIN   IF  p^.n = NIL   THEN RETURN END;
p:=  p^.n; INC(z);  IF  y < WindowZeilen  THEN INC(y)  END;
END incp;

PROCEDURE    zeilevor;
BEGIN   IF  p^.n = NIL   THEN RETURN END;  speichern (p,s);  incp;  laden ;
END zeilevor;

PROCEDURE    zeilezurueck;
BEGIN   IF  p^.v = NIL   THEN RETURN END;  speichern (p,s);  decp;  laden ;
END zeilezurueck;

PROCEDURE    speichern ( p : pzeile; VAR s:  ARRAY  OF CHAR  );
VAR     h: CARDINAL;
BEGIN   test ( p <>  NIL ,"speichern");
DEALLOCATE (p^.q,  p^.h +1 );  h:= Length(s);   ALLOCATE (p^.q, h+1 );
Move ( ADR (s), p^.q, h+1 );   p^.h := h;
END     speichern ;

PROCEDURE    abspeichern;
BEGIN        kuerzen; speichern (p, s );  END abspeichern;

PROCEDURE    laden;
BEGIN        Move (p^.q, ADR(s),  p^.h+1);        END laden;

PROCEDURE    linken ( VAR  x,y: pzeile );
BEGIN
IF      x <> NIL   THEN  x^.n := y   END;
IF      y <> NIL   THEN  y^.v := x   END;
END     linken;

PROCEDURE    erzeugen ( VAR  p: pzeile;  VAR  s: ARRAY OF CHAR  );
VAR     h: CARDINAL;
BEGIN
h:= Length( s);  NEW (p);  p^.v := NIL; p^.n := NIL;  p^.h := h;
ALLOCATE (p^.q, h+1 );   Move(ADR (s), p^.q,  h+1 );
END erzeugen;

PROCEDURE    freigeben ( p: pzeile );
BEGIN   DEALLOCATE (p^.q, p^.h +1 );  DISPOSE( p);
END freigeben;

PROCEDURE    einfuegen (  p: pzeile;  VAR  s: ARRAY OF CHAR  );
VAR     pn, x: pzeile;
BEGIN
pn := p^.n;  erzeugen (x,s );  linken (p,x ); linken (x,pn );
IF      x^.v = NIL    THEN  anfang := x;   END;
END einfuegen;

PROCEDURE    loeschen ( VAR  p: pzeile );
VAR     pn,pv: pzeile;
BEGIN
IF      p    = NIL      THEN  RETURN  END;
IF      p^.n = NIL      THEN   einfuegen (p, empty);   END;
pv:=p^.v; pn:=p^.n;   freigeben (p);  linken (pv, pn );  p := pn;
IF      p^.v = NIL      THEN  anfang := p; END;
END loeschen;

PROCEDURE    verketten ( p: pzeile );
VAR     i: CARDINAL;pn,pnn: pzeile;  s2: string;
BEGIN
IF      (p = NIL )  OR  ( p^.n =  NIL  ) THEN    piepsen(0);  RETURN ; END;
pn := p^.n;
skipblanks (pn^.q, 0, i );
IF      p^.h + p^.n^.h -i > MaxSpalten THEN    piepsen(0);  RETURN ; END;
IF      i> 0   THEN
        Copy (s2, pn^.q^ ); Delete(s2, 0, i-1 ); speichern( pn, s2 );
END;
Concat (s2, p^.q^, p^.n^.q^);  speichern (p,s2);
pnn := p^.n^.n;  freigeben (p^.n ); linken (p, pnn );
END     verketten;

PROCEDURE    splitten ( p: pzeile;   x: CARDINAL );
VAR     pnn: pstring;  s, teil1, teil2: string;   h: CARDINAL;
BEGIN   teil1 :=""; teil2:="";
Slice ( teil1, p^.q^, 0  , x-1        ); (*  x-1 >= 0  zeichen *)
Slice ( teil2, p^.q^, x-1, MaxSpalten ); (*  der rest ab position x-1 *)
speichern (p, teil1 );  einfuegen ( p, teil2 );  (* kein laden ! *)
END     splitten;

PROCEDURE    zeilenloeschen ( a,b: pzeile );
VAR     x, xn, av, bn : pzeile; h: CARDINAL;
BEGIN
IF   ( a = NIL )  OR  (a^.v = NIL )    OR ( b= NIL )   OR ( b^.n =  NIL )
THEN    fehler ("zeilenloeschen ")   END;
av := a^.v;  bn := b^.n;  x := a;
WHILE ( x <> b ) AND ( x <> NIL )
  DO xn := x^.n; freigeben (x ); x:= xn;  END;
test( x= b, "zeilenloeschen");  freigeben (b);  linken (av, bn );
END     zeilenloeschen ;

PROCEDURE    texteinfuegen ( p,a: pzeile );
VAR     x, xn, av, bn : pstring ; h: CARDINAL;
BEGIN
WHILE ( a <> NIL ) DO
        IF   NOT Storage.Available (10000)   THEN piepsen(0); RETURN; END;
        einfuegen (p,a^.q^ );  p := p^.n;  a := a^.n ;
END;
END     texteinfuegen ;

PROCEDURE    textloeschen ( VAR  a: pzeile );
VAR     an : pzeile ; h: CARDINAL;
BEGIN   WHILE ( a <> NIL   )  DO an := a^.n; freigeben (a ); a:= an;  END;
a :=  NIL;
END     textloeschen ;

PROCEDURE    xInScreen():  BOOLEAN;
BEGIN   RETURN ( linkerrand < x)  AND  ( x <= linkerrand+ WindowSpalten ) ;
END  xInScreen;

PROCEDURE    ScreenTox;
BEGIN
IF      x <= linkerrand  THEN  linkerrand := x-1
ELSIF  x > linkerrand + WindowSpalten   THEN  linkerrand:=  x- WindowSpalten   END;
END  ScreenTox;

(*======================= Userbefehle ==================================*)

PROCEDURE    zeicheneinfuegen;
VAR   h: CARDINAL;
BEGIN
IF      x > Spalten + 1    THEN piepsen(0)        ; RETURN; END;
IF      x = Spalten + 1    THEN zeilenumbruch  ; RETURN; END;
kuerzen;  auffuellen; h:= Length (s);
IF      h >=Spalten        THEN piepsen(0)        ; RETURN; END;
(* h>= x-1 *)
Insert ( s, taste, x-1 )  ; INC(x); abspeichern; quickshow;
END  zeicheneinfuegen;

PROCEDURE    zeichenueberschreiben;
VAR   h: CARDINAL;
BEGIN
IF      x > Spalten + 1    THEN piepsen(0)        ; RETURN; END;
IF      x = Spalten + 1    THEN zeilenumbruch  ; RETURN;   END;
(*  1<= X <= Spalten  *)
auffuellen; (* h >= x-1*)  IF s[x-1] = 0C  THEN  s[x]:= 0C;  END;
s[x-1] := taste[0];  INC(x); abspeichern; quickshow;
END  zeichenueberschreiben;

PROCEDURE    zeilenumbruch;
VAR
        i,j,h: CARDINAL;
        neuezeile, rand, wort:  string;
BEGIN   (*  x = Spalten +1 *)
kuerzen;  auffuellen;  (*  h >= x -1 >= Spalten *); h := Length (s);
IF h > Spalten   THEN piepsen(1); RETURN; END;
(* h = Spalten *)
rand :="";  wort := "";  neuezeile := "";
i:= randbreite(); (* i <= x-1 *)
IF      i < h    THEN  Slice (rand, s,0, i ); ELSE i:= 0;   END;
IF      (s[h-1] <> ' ') AND  (taste[0] <> ' ' )  THEN
        (* wortumbruch *)
        WHILE  (h > 0 ) AND (s[h-1] <> ' ' ) DO  DEC(h);  END ;
        INC(h); (* h >0 and s[h-1] <> ' '  ===> i <= h-1  *)
        IF      i=h-1   THEN piepsen(0); RETURN; END;
                (* NUR EIN WORT IN DER ZEILE: umbruch nicht moeglich! *)
        j:= Spalten -h +1 ; (* wortlaenge *)
        Slice ( wort, s, h-1, j );   INC (i , j );
        s[h-1]:=0C; abspeichern;
        Concat (rand, rand, wort );
END;
Concat ( neuezeile, rand, taste );
einfuegen (p, neuezeile );
zeilevor; test ( i+2 <= x, "zeilenumbruch" ) ;  x:= i+2;
(* bei einem wortumbruch wurden mindestens 2 zeichen eliminiert.
fand kein wortumbruch statt, so ist der rand entweder 0 oder mindestens
2 zeichen kuerzer als x *)
seiteausgeben;
END  zeilenumbruch;

PROCEDURE    zeichenloeschen;
VAR   h: CARDINAL;
BEGIN
kuerzen; h:= Length (s);
IF      h>=x    THEN
        Delete (s,x-1,1 );      quickshow;
ELSIF   verkettenmoeglich()  THEN
        auffuellen;  (* h = x-1*) ;speichern(p,s); verketten(p);
        seiteausgeben;
END;
END  zeichenloeschen;

PROCEDURE    verkettenmoeglich():  BOOLEAN;
VAR   i: CARDINAL;
BEGIN   IF   p^.n = NIL  THEN  RETURN FALSE; END;
skipblanks(p^.n^.q,0,i );
RETURN  x-1  + p^.n^.h - i < Spalten ;
END          verkettenmoeglich;

PROCEDURE    zeichenvorherloeschen;
VAR   h: CARDINAL;
BEGIN
h:= Length (s); DEC(x); (*  x<= Spalten *)
IF      x < 1    THEN
        IF      (p^.v = NIL ) OR (p^.v^.h > Spalten)
          THEN INC(x);  RETURN ; END;
        x:= max(1,p^.v^.h);  zeilezurueck; zeichenloeschen;
        IF      h= 0    THEN  loeschen (p^.n ); END;
        quickshow; seiteausgeben;
ELSE    Delete (s, x-1, 1 ); quickshow;  END;
END  zeichenvorherloeschen;

PROCEDURE    zeileeinfuegen;  (*  durch enter *)
VAR     i, h: CARDINAL;
        rand, rest, neuezeile: string;
BEGIN
test ( x <= MaxSpalten +1 , "zeileeinfuegen");
kuerzen; auffuellen;  (* h>=x-1 <= MaxSpalten *)
rest:="";   rand :="";
i := randbreite();  (*  i <= x-1 *)
Slice ( rand, s, 0  , i );
Slice ( rest, s, x-1, MaxSpalten );
Concat ( neuezeile,rand, rest);
s[x-1]:= 0C;
einfuegen (p, neuezeile );  zeilevor;
x:= min ( x, randbreite() +1 );    seiteausgeben;
END  zeileeinfuegen;

PROCEDURE    scrollup; (*  up entspricht der bewegungsrichtung *)
(*      +-------------+      +----------------+   +------------------+
        !a            !      !b zeile         !   !c    zeile        !
        !b zeile      !      !c               !   !                  !
        !c            !      !                !   !                  !
        +-------------+      +----------------+   +------------------+  *)
VAR  t:  pzeile;
BEGIN
abspeichern ;
IF      y> 1   THEN  DEC(y)
ELSIF  p^.n <> NIL  THEN   p:= p^.n; INC(z)  END;
laden;
END     scrollup;

PROCEDURE    scrolldown; (*   entspricht der bewegungsrichtung *)
(*      +-------------+      +----------------+   +------------------+
        !a            !      !                !   !                  !
        !b zeile      !      !a               !   !                  !
        !c            !      !b  zeile        !   !a  zeile          !
        +-------------+      +----------------+   +------------------+  *)
VAR  t:  pzeile;
BEGIN
abspeichern ; t:= top();  IF   t^.v = NIL    THEN  RETURN  END;
IF      y< WindowSpalten      THEN  INC(y)
ELSE    p:= p^.v; DEC(z)  END;
laden;
END     scrolldown;

PROCEDURE    seitezurueck;
VAR   j: CARDINAL;
BEGIN  abspeichern ; j:=0;
WHILE   (j< WindowZeilen)  AND (z >  y )   DO   p:= p^.v;  DEC(z)  END;
laden;
END     seitezurueck;

PROCEDURE    naechsteseite;
VAR   j: CARDINAL;
BEGIN  abspeichern ; j:=0;
WHILE   (j< WindowZeilen)  AND ( p^.n <> NIL  )
  DO   p:= p^.n;  INC(z)  END;
laden;
END     naechsteseite;

PROCEDURE     zeilenanfang;
BEGIN         x:= min (x, randbreite()+1 );
END     zeilenanfang;

PROCEDURE    zeilenende;
BEGIN   x:=  min(Spalten+1, Length (s)+1 ) ;  END  zeilenende;

PROCEDURE    seitenanfang;
BEGIN   abspeichern ; WHILE y > 1  DO  decp END; laden ;
END  seitenanfang;

PROCEDURE    seitenende;
BEGIN   abspeichern ;
        WHILE (y < WindowZeilen )  AND ( p^.n <> NIL ) DO incp END; laden;
END     seitenende;

PROCEDURE    cursorup;
BEGIN   IF p^.v  =  NIL  THEN RETURN END; abspeichern ;  decp; laden;
END     cursorup;

PROCEDURE    cursordown;
BEGIN   IF p^.n  =  NIL  THEN RETURN END; abspeichern ;  incp; laden;
END     cursordown;

PROCEDURE    cursorleft;
BEGIN   decx;   END     cursorleft;

PROCEDURE    cursorright;
BEGIN   IF x < MaxSpalten THEN INC(x) END;  END     cursorright;

PROCEDURE    wortnachrechts;
VAR     h: CARDINAL;
BEGIN
test ( x> 0, "wortnachrechts: x>0");
h:= Length( s);  nextwordchar;
IF      x<= h   THEN RETURN  END;
abspeichern ;
WHILE   (p^.n <> NIL )  AND ( x > h ) DO
        incp; laden; x:=1;  h:= Length( s);
        IF      s[0] IN  alphanumerisch  THEN RETURN END;
        nextwordchar;
END; (* WHILE *)
END     wortnachrechts;

PROCEDURE    nextwordchar;
VAR     h: CARDINAL;
BEGIN   h:= Length ( s);
WHILE   (x <= h)  AND     ( s[x-1] IN  alphanumerisch ) DO  INC(x) END;
WHILE   (x <= h)  AND  NOT( s[x-1] IN  alphanumerisch ) DO  INC(x) END;
END     nextwordchar;

PROCEDURE    wortnachlinks;  (* an den anfang des vorhergehenden wortes *)
VAR     h: CARDINAL;
BEGIN   h:= Length ( s);  IF  x> h  THEN  x:= h END;
(*0<=x <= h  *)
WHILE   (x>= 1 )  AND  (s[x-1] IN  alphanumerisch )   DO DEC(x)   END;
IF      x >= 1 THEN  FirstOfPrevWord  END;
IF      x >= 1  THEN RETURN  END;
abspeichern ;
WHILE    x <  1   DO
        IF      p^.v =  NIL   THEN  x:=1;  RETURN   END;
        decp; laden; x := Length(s);
        FirstOfPrevWord;
END;    (* WHILE *)
END     wortnachlinks;

PROCEDURE    FirstOfPrevWord;
BEGIN
IF       x <1   THEN  RETURN END;
(*       1<=x<= h *)
WHILE   (x>=1)  AND   NOT( s[x-1] IN  alphanumerisch  )  DO DEC(x)   END;
WHILE   (x>=1)  AND      ( s[x-1] IN  alphanumerisch  )  DO DEC(x)   END;
(*  x wurde vermindert *)
IF      s[x] IN  alphanumerisch   THEN  INC(x) END;
END     FirstOfPrevWord;

PROCEDURE    Ausgabe;
BEGIN
IF      (NOT  xInScreen() )  OR  topchanged()  THEN seiteausgeben; END;
saveyz;  Window.GotoXY( x -linkerrand, y+1 );
END     Ausgabe;

PROCEDURE    StatusZeile;
BEGIN
Window.GotoXY(1,1);
IO.WrStr("s:");             IO.WrCard(z,5);
IO.WrStr(" Spalte:");           IO.WrCard(x,5);
IF   Einfuegemodus   THEN         IO.WrStr(" Einf.")
ELSE   IO.WrStr(" Ueberschr.")   END;
Window.ClrEol;
END     StatusZeile;

PROCEDURE    HeapTesten;
BEGIN   IF NOT Storage.Available ( 10000)  THEN fehler ("heaptesten ") END;
END     HeapTesten;

PROCEDURE    Help;
BEGIN   END  Help;

PROCEDURE    Suchen;
BEGIN   END  Suchen;

PROCEDURE    Aendern;
BEGIN   END  Aendern;

PROCEDURE    WeiterSuchen;
BEGIN   END  WeiterSuchen;

PROCEDURE    WeiterAendern;
BEGIN   END  WeiterAendern;

PROCEDURE    SpaltenAendern;
BEGIN        IF  x < MaxSpalten  THEN  Spalten :=  x;  END;
END  SpaltenAendern;

PROCEDURE    befehlausfuehren;
BEGIN
CASE    comand   OF
        ControlK        :  Blockoperation;
      | ControlQ        :
        (* Helpzeile anpassen, Modus = ControlQ *)
        RdCom (comand, key ); taste[0]  := key;
        WHILE   NOT ((comand = ESC )
                OR ( comand = NOCOM ) AND ( capkey() IN ControlQOptions ))
        DO      piepsen (8); RdCom (comand, key); taste[0] :=key;  END;
        IF      comand<> ESC  THEN (* OPERATION AUFRUEFEN *) END;
      | F1              :  Help;
      | F2              :  SpaltenAendern;
      | F3              :  WeiterSuchen;
      | F4              :  WeiterAendern;
      | F5              :  Suchen;
      | F6              :  Aendern;
      | F7,ALTF7        :  Blocksatz;
      | HOME            :  zeilenanfang;
      | UP              :  cursorup;
      | PGUP            :  seitezurueck;
      | LEFT            :  cursorleft;
      | RIGHT           :  cursorright;
      | ENDKEY          :  zeilenende;
      | DOWN            :  cursordown;
      | PGDOWN          :  naechsteseite;
      | INS             :  Einfuegemodus :=  NOT( Einfuegemodus);
      | BACKSPACE       :  zeichenvorherloeschen;
      | DEL             :  zeichenloeschen;
      | ControlLEFT     :  wortnachlinks;
      | ControlRIGHT    :  wortnachrechts;
      | ControlHOME     :  seitenanfang;
      | ControlEND      :  seitenende;
      | ENTER           :  zeileeinfuegen ;
      | NOCOM        :  IF    Einfuegemodus=TRUE
                           THEN  zeicheneinfuegen
                           ELSE  zeichenueberschreiben   END;
END; (*case*);
END     befehlausfuehren;

PROCEDURE    Blockoperation;
VAR
a,b     : position;
i       : CARDINAL;
BEGIN
(* Aufruf mit ControlK, Modus aendern, Options in der Helpzeile ausgeben *)
RdCom ( comand, key );
IF      (comand = NOCOM ) AND ( capkey() IN zeichen{'C','Y','O'} )  THEN
        CASE    capkey()       OF
                'C'     :  texteinfuegen (p, ablage );
        |       'Y'     :  textloeschen ( ablage );
        |       'O'     :  (*uebereinanderkopieren*);
        END;
        RETURN;
END;
blockdefinieren (a, b);
IF      comand = ESC    THEN  RETURN END;
CASE    capkey()      OF
        'C'     :  blockloeschen (a,b);
|       'Y'     :  (*blocksichern ( a,b)  *);
|       '-'     :  blocknachlinks (a,b );
|       '+'     :  blocknachrechts (a,b );
END;
END     Blockoperation;

PROCEDURE    uebereinanderkopieren;
BEGIN  ; END uebereinanderkopieren;

PROCEDURE    blocknachlinks  ( VAR a,b : position );
BEGIN  ; END blocknachlinks;

PROCEDURE    blocknachrechts ( VAR a,b : position );
BEGIN  ; END blocknachrechts ;

PROCEDURE    capkey() :  CHAR;
VAR          c: string1;
BEGIN        c:= taste; Str.Caps(c);  RETURN c[0] ; END   capkey;

PROCEDURE    blockdefinieren ( VAR a,b : position );
VAR  i  : CARDINAL;
BEGIN   (* modus : block definieren,Optionen ausgeben   *)
positionmerken ( a );   b:= a;
WHILE   NOT (   (comand = ESC )   OR
        ((comand = NOCOM ) AND (capkey() IN zeichen{'Y','C','+','-'} ))) DO
        (*  es fehlen  noch r,w,p  *)
        IF      comand IN CursorVeraendern  THEN
                befehlausfuehren ;
                positionmerken (b );
                blockanzeigen(a,b);
                (* CursorVeraendern setzt keine anzeige *)
        ELSE    piepsen (12);  END;
        RdCom( comand, key );
END;
END     blockdefinieren;

PROCEDURE    positionmerken ( VAR c: position );
BEGIN   c.p := p; c.z:=z; c.y := y;   c.x := x;
END     positionmerken;

PROCEDURE    positionaktivieren ( c: position );
BEGIN   p:=c.p ; z:= c.z;  y :=  c.y;  x :=c.x;
END     positionaktivieren;

PROCEDURE    blockloeschen ( VAR a,b: position );
BEGIN
(* die obere Marke mu aktiviert werden ! *)
sortieren (a,b ); positionaktivieren (b);
IF      (a.p = b.p )     THEN
        Delete (s, a.x -1, b.x -a.x +1 ); abspeichern ; RETURN;
END;
Delete (s, 0, b.x-1 );  abspeichern;
positionaktivieren (a);
Delete (s, a.x-1, MaxSpalten  ); abspeichern;
IF      a.p^.n <>  b.p    THEN  zeilenloeschen ( a.p^.n, b.p^.v ) END;
verketten (p);
END     blockloeschen;

PROCEDURE    blockablegen  ( a,b: position );
VAR     s: string;
        x,t: pzeile;
BEGIN   s:="";
sortieren (a,b ); textloeschen (ablage );
IF      (a.p = b.p )     THEN
        Slice ( s, a.p^.q^, a.x -1,  b.x-a.x+1 );
        erzeugen (ablage, s );   RETURN;
END;
s:="";Slice ( s, a.p^.q^, a.x-1, MaxSpalten   );
erzeugen (ablage, s);  x := ablage; t := a.p^.n;
WHILE   Storage.Available (10000) AND   (t <> b.p )  DO
        einfuegen (x, t^.q^);  t:=t^.n;  x:=x^.n;
END;
s:=""; Slice ( s, b.p^.q^, 0 , b.x-1     );
einfuegen (x, s );
END     blockablegen;

PROCEDURE    blockanzeigen ( a1,b1: position );
VAR     a,b: position;  t: pzeile;
BEGIN   t:= top ();  test ( p = b1.p , "blockanzeigen");
ausschnitt (a1,b1, a, b );
zeilenausgeben ( 1, a.y -1,  t );
IF      a.y = b.y     THEN  abzeileanzeigen (a, b );
ELSE    azeileanzeigen (a);
        Invers; zeilenausgeben (a.y +1, b.y -1, a.p^.n );   Invers;
        bzeileanzeigen (b);
END;
zeilenausgeben( b.y+1, WindowZeilen,  b.p^.n );
END     blockanzeigen;

PROCEDURE    azeileanzeigen ( a: position);
VAR     p : pzeile;  x,y,k,i,h: CARDINAL;
        s : string;
BEGIN   p := a.p;   x:= a.x;   y := a.y;
IF      x> linkerrand + WindowSpalten
  THEN  ausgeben  (p,y);  RETURN; END;
IF      x<=linkerrand
  THEN  Invers; ausgeben  (p,y);  Invers; RETURN; END;
(*  x ist InScreen ===>  virtuelle zeile aufbauen  *)
INC(y); virtuellezeile(p, ADR(s));
i:= x-linkerrand;
IF      i> 1 THEN DirectWrite (1,y,    ADR(s[0]  ), i-1 );  END;
Invers ;          DirectWrite (i,y,    ADR(s[i-1]), WindowSpalten-i+1 );
Invers;
END     azeileanzeigen;

PROCEDURE    bzeileanzeigen ( b: position);
VAR     p : pzeile;  x,y,k,i,h: CARDINAL;
        s : string;
BEGIN   p := b.p;   x:= b.x;   y := b.y;
IF      x> linkerrand + WindowSpalten
  THEN  Invers; ausgeben  (p,y);Invers;  RETURN; END;
IF      x<=linkerrand           THEN  ausgeben  (p,y);  RETURN; END;
(*  x ist InScreen ===>  virtuelle zeile aufbauen  *)
INC(y); virtuellezeile(p, ADR(s));
i:= x-linkerrand;  Invers;
DirectWrite (1  ,y,   ADR(s[0]  ), i );   Invers;
IF   i < WindowSpalten
  THEN   DirectWrite (1+i,y,   ADR(s[i])  , WindowSpalten-i);
END;
END     bzeileanzeigen;

PROCEDURE    abzeileanzeigen ( a,b: position);
VAR     p : pzeile;  x,y,k,i,ai,bi,h: CARDINAL;
        s : string;
        aInScreen, bInScreen: BOOLEAN;
BEGIN   p := b.p;   x:= b.x;   y := b.y;
aInScreen := (linkerrand < a.x )  AND ( a.x <= linkerrand + WindowSpalten );
bInScreen := (linkerrand < b.x )  AND ( b.x <= linkerrand + WindowSpalten );
IF      NOT aInScreen   THEN  bzeileanzeigen ( b);
ELSIF   NOT bInScreen   THEN  azeileanzeigen ( a);
ELSE
INC(y); virtuellezeile(p, ADR(s));
ai := a.x - linkerrand;  bi := b.x-linkerrand ;
IF   ai  >  1    THEN   DirectWrite (1   ,y ,   ADR(s[0])    , ai-1    );
END;
Invers;                 DirectWrite (ai  ,y ,   ADR(s[ai-1]) , bi-ai +1);
Invers;
IF  bi < WindowSpalten
  THEN   DirectWrite (bi+1,y ,   ADR(s[bi]) , WindowSpalten-i);
END;
END; (* ELSE *)
END     abzeileanzeigen;

PROCEDURE    ausschnitt ( a,b: position;  VAR aa,bb: position );
VAR     o,u: position;
BEGIN   (* b.p ist aktiv *)
linksoben (a,b,o);  rechtsunten (a,b,u);
test ( (o.z <= b.z ) AND ( b.z <= u.z ), "ausschnitt");
aa := a;
IF      a.z <  o.z    THEN  aa := o;  END;
IF      a.z >  u.z    THEN  aa := u;  END;
bb := b;  (* aa und bb sind nun auf dem Bildschirm *)
sortieren (aa,bb);
END     ausschnitt;

PROCEDURE    sortieren ( VAR a,b: position);
VAR     c: position;
BEGIN   (* b.p ist aktiv *)
IF      (a.z >  b.z )  OR   ((a.z = b.z )  AND  ( a.x > b.x ))
THEN  c:= a;  a:= b;  b:= c;  END;
END     sortieren;

PROCEDURE    linksoben ( a,b: position;  VAR c: position);
BEGIN   (* b.p ist aktiv *)
c.p := top();  c.z := z-y+1 ;  c.y := 1; c.x := 1;
END     linksoben;

PROCEDURE    rechtsunten  ( a,b: position;  VAR c: position);
BEGIN   (* b.p ist aktiv *)
c.p := p; c.y := y ; c.z := z; c.x := linkerrand+ WindowSpalten;
(*c.x  ist nur fr die anzeige relevant. fr die operation werden dann
die echten blockmarken verwendet *)
WHILE ( c.p^.n <> NIL )  AND   ( c.y   < WindowZeilen )  DO
        c.p := c.p^.n;  INC (c.z);  INC(c.y );
END;
END     rechtsunten;

PROCEDURE    Blocksatz;
VAR     i,j, w,w2, laenge          : CARDINAL;
        rand, wort, neuezeile      : string;
        pv , a ,b                  : pzeile;
        pq                         : pstring;

PROCEDURE    wortvorhanden (  i: CARDINAL; VAR w: CARDINAL ): BOOLEAN;
VAR     k : CARDINAL;
BEGIN
IF      pq^[i] =0C   THEN  (* p ist abgearbeitet *)
        loeschen (p); laden; pq :=p^.q; skipblanks(pq,0,i );
        IF      pq^[i]=0C    THEN RETURN (FALSE ); END;
END;
nextblank(pq,i,k); w := k-i+1;
IF      x-1 + w > Spalten    THEN
        Slice(s,s,i,MaxSpalten); abspeichern; piepsen(0); RETURN (FALSE);
        (* der abgearbeitete teil wird geloescht *)
END;
IF pq^[k] =0C THEN DEC(w) END; RETURN (TRUE );
END          wortvorhanden;

BEGIN   (*Blocksatz*)
IF      x > Spalten        THEN  RETURN ;  END;
pq:=p^.q; auffuellen;  skipblanks (pq,0,i);
IF      i<> x-1  THEN  piepsen(6); RETURN;  END;
        (* der cursor mu auf dem ersten nicht-blank der zeile stehen*)
nextblank(pq,i,j); w := j-i+1; IF pq^[j] =0C THEN INC(w) END;
IF      x-1+w > Spalten  THEN piepsen(0); RETURN;  END;
        (* bereits das erste "wort" ist zu lang *)
Slice (rand, leerzeile, 0,x-1);
Move  (ADR(neuezeile), ADR (rand), x);   laenge :=x-1;
erzeugen (a,neuezeile); b :=a ;
WHILE   ( wortvorhanden (i,w) = TRUE )  DO
        (* eine wort ab position i ist einen folge (nichtblank)...<blank>
        der laenge w mit x-1+w <= Spalten. fehlt das abschlieende blank,
        so muss x-1+w < Spalten sein *)
        w2:=w; Slice (wort, pq^, i, w );
        IF      pq^[i+w] <> ' '  THEN Concat( wort, wort," "); INC(w2) END;
        IF      laenge+w2 > Spalten   THEN
                (* neuezeile hat keinen platz mehr, ist also fertig *)
                IF  comand = ALTF5
                  THEN blankseinstreuen (ADR(neuezeile)) END;
                speichern (b, neuezeile);
                Move (ADR(neuezeile), ADR(rand), x ); laenge :=x-1;
                einfuegen (b, neuezeile);  b:= b^.n;
        END;
        Concat ( neuezeile, neuezeile, wort ); INC( laenge, w);
        skipblanks(pq,i+w,i );  (* diese leerzeichen werden eliminiert *)
END;
speichern (b, neuezeile );
linken (pv, a);  linken ( b, p );  IF  pv =  NIL  THEN  anfang := p END;
p:=a; (*  y,z sind unverndert *)
laden; seiteausgeben;
END          Blocksatz;

PROCEDURE    blankseinstreuen ( ps: pstring );
VAR     fehlendeblanks,k,i,j: CARDINAL;
BEGIN
i:=x-1; nextblank(ps,j,i ); skipblanks(ps,i, j);
IF      s[j] = 0C   THEN RETURN END;  (* nur ein wort in der zeile *)
nextblank(ps,j,i ); k :=0; fehlendeblanks := Spalten - Length(s); k:=0;
WHILE  ( k < fehlendeblanks ) DO
        Insert(s, " ", i);  INC(k);
        skipblanks ( ps, i,j); nextblank (ps,j,i );
        IF      s[i] = 0C   THEN  nextblank( ps, x-1, i )  END;
END;
END          blankseinstreuen;

PROCEDURE    nextblank (p: pstring;  i: CARDINAL;  VAR j:   CARDINAL );
VAR
BEGIN        j:= i ;
IF        p^[j] = 0C   THEN   RETURN END;
WHILE   ( p^[j] <> 0C)  AND ( p^[j] <> ' ' )  DO INC (j);  END;
END          nextblank;

PROCEDURE    skipblanks (  p: pstring; i: CARDINAL;   VAR j:   CARDINAL );
BEGIN        j:= i ;
WHILE   ( p^[j] = ' ' )  DO INC (j);  END;
END          skipblanks;

PROCEDURE    InitEditor;
VAR  i  : CARDINAL;
BEGIN

Spalten                 := 100;  test (Spalten < MaxSpalten ,"Spalten");


FensterDef := Window.WinDef( 3,3,  40,10 ,
              Window.White, Window.Black,
              TRUE, TRUE, FALSE, TRUE, Window.SingleFrame,
              Window.Black, Window.Black );
WindowZeilenGesamt :=  FensterDef.Y2  - FensterDef.Y1 + 1;
WindowSpaltenGesamt:=  FensterDef.X2  - FensterDef.X1 + 1;

IF      FensterDef.FrameOn
THEN    WindowZeilen := WindowZeilenGesamt -4;
        WindowSpalten := WindowSpaltenGesamt - 2;
ELSE    WindowZeilen := WindowZeilenGesamt -2;
        WindowSpalten := WindowSpaltenGesamt    ;
END;

FOR     i:= 0  TO  Window.ScreenWidth-1 DO  leerzeile[i]:=' ' END;
leerzeile[Window.ScreenWidth]:=0C;
empty := "";
taste[1] := 0C;
CursorVeraendern := befehlsmenge{UP,DOWN,LEFT,RIGHT};
alphanumerisch   := zeichen{'a'..'z','A'..'Z','0'..'9'};
Einfuegemodus    := TRUE;
erzeugen ( anfang, empty);  p := anfang;  laden;
x:=1; y:= 1; z:= 1; linkerrand :=0;
Fenster          := Window.Open ( FensterDef );

test    (WindowSpalten > 1   , "INITEDITOR: WindowSpalten> 1        ");
test    (WindowZeilen  > 1   , "INITEDITOR: WindowZeilen > 1        ");


END     InitEditor;

BEGIN   (*  edtest *)

InitEditor;
AktiveBefehle:= befehlsmenge{NOCOM,INS,ENTER,UP,DOWN,LEFT,RIGHT,
                ControlLEFT, ControlRIGHT,DEL,BACKSPACE,HOME,ENDKEY};
REPEAT
        StatusZeile;
        HeapTesten;
        Ausgabe;
        IF      Fehlerkontext <> 0       THEN  HelpHinweis END;
        RdCom (comand, key);  taste[0] := key;
        IF      comand <> F1                THEN  Fehlerkontext := 0;  END;
        IF      comand IN   AktiveBefehle   THEN  befehlausfuehren END;
UNTIL   comand= ESC;
END     edtest.

