IMPLEMENTATION  MODULE  eduserop;

TYPE

VAR
taste           :  ARRAY[0..1] OF  CHAR;
befehl          :  befehle;
key             :  CHAR;
alphanumerisch  :  befehlszeichen;

PROCEDURE      BlanksEinstreuen ( q: pstring);  FORWARD;
PROCEDURE      Blocksatz  (anzeigen: BOOLEAN);  FORWARD;
PROCEDURE      ZeileLoeschen ;                  FORWARD;

PROCEDURE      keys ( optionen: ARRAY OF CHAR ): BOOLEAN;
               (* prueft, ob der benutzer eine zulaessige option
               eingegeben hat *)
VAR            i: CARDINAL;   v: ARRAY[0..1] OF CHAR;
BEGIN
v:=""; v[0]:= Capital(key);
RETURN (befehl = NOCOM ) AND (Str.Pos(optionen,v) <> MAX(CARDINAL) );
END            keys;



PROCEDURE    BefehlAusfuehren ( b: befehle;  eingabezeichen: CHAR );
BEGIN
befehl   := b;
key      := eingabezeichen;
taste[0] := key; taste[1]:= 0C;

CASE    befehl   OF
	ControlK        :  Blockoperation;
      | F1              :  Help;
      | F2              :  SpaltenAendern;
      | F3              :  WeiterSuchen;
      | F4              :  WeiterAendern;
      | F5              :  Suchen;
      | F6              :  Aendern;
      | F7,F8           :  Blocksatz(TRUE );
      | F9              :  Dokumentenmodus := NOT Dokumentenmodus;
      | F10             :  Blocksatzmodus  := NOT Blocksatzmodus;
      | INS             :  Einfuegemodus   := NOT Einfuegemodus;
      | HOME            :  ZumZeilenanfang;
      | ENDKEY          :  ZumZeilenende;
      | UP              :  CursorUp;
      | LEFT            :  CursorLeft;
      | RIGHT           :  CursorRight;
      | DOWN            :  CursorDown;
      | PGDOWN          :  SeiteVor;
      | PGUP            :  SeiteZurueck;
      | BACKSPACE       :  ZeichenVorherLoeschen;
      | DEL             :  ZeichenLoeschen;
      | ControlY        :  ZeileLoeschen;
      | ControlLEFT     :  WortNachLinks;
      | ControlRIGHT    :  WortNachRechts;
      | ControlHOME     :  ZumTextanfang;
      | ControlEND      :  ZumTextende;
      | ControlPGUP     :  ScrollenVor;
      | ControlPGDOWN   :  ScrollenZurueck;
      | ENTER           :  ZeileEinfuegen ;
      | NOCOM           :  IF    Einfuegemodus THEN  ZeichenEinfuegen
			   ELSE                      ZeichenUeberschreiben   END;
END; (*case*);
END     BefehlAusfuehren;




PROCEDURE    ZeichenUeberschreiben;
VAR   h: CARDINAL;
BEGIN
IF      x >= Spalten + 1    THEN piepsen(3)        ; RETURN; END;
(*  1<= X <= Spalten  *)
Auffuellen; (* h >= x-1*)  IF s[x-1] = 0C  THEN  s[x]:= 0C;  END;
s[x-1] := key;  INC(x); Abspeichern; QuickShow;
END  ZeichenUeberschreiben;





PROCEDURE    ZeichenEinfuegen1;
VAR   h: CARDINAL; ok: BOOLEAN ;
BEGIN
Kuerzen;  h:= Length (s);
IF      (x > Spalten) OR (h >= Spalten )  THEN  piepsen(4)  ; RETURN; END;
(* h < Spalten *)
Auffuellen; (* h-1 >= x*)
Insert ( s, taste, x-1 )  ; INC(x);    QuickShow;
END          ZeichenEinfuegen1;





PROCEDURE    ZeichenEinfuegen2;
VAR   h,x2: CARDINAL; ok: BOOLEAN ;
BEGIN        ZeichenEinfuegen1;
(* ZeichenEinfuegen2 wir erst in der naechsten ausgabe vorgestellt *)
END  ZeichenEinfuegen2;







PROCEDURE    ZeichenEinfuegen;
BEGIN
IF  Dokumentenmodus  THEN ZeichenEinfuegen1 ELSE ZeichenEinfuegen2 END;
END          ZeichenEinfuegen;






PROCEDURE    ZeichenLoeschen;
VAR   h: CARDINAL;
BEGIN
Kuerzen; h:= Length (s);
IF      h>=x    THEN
	Delete (s,x-1,1 );      QuickShow;
ELSIF   VerkettenMoeglich(p)  THEN
	Auffuellen;  (* h = x-1*) ;Speichern(p,s); Verketten(p); Laden;
	SeiteAusgeben;
ELSE    piepsen (4)
END;
END  ZeichenLoeschen;




PROCEDURE    ZeichenVorherLoeschen;
VAR   h: CARDINAL;
BEGIN
h:= Length (s); DEC(x); (*  x<= Spalten *)
IF      x < 1    THEN
	IF      (p^.v = NIL ) OR (p^.v^.h > Spalten)  THEN INC(x);  RETURN ; END;
	x:= max(1,p^.v^.h);  ZeileZurueck; ZeichenLoeschen;
	IF      h= 0    THEN  Loeschen (p^.n ); END;
	QuickShow; SeiteAusgeben;
ELSE    Delete (s, x-1, 1 ); QuickShow;  END;
END  ZeichenVorherLoeschen;







PROCEDURE    ZeileEinfuegen;  (*  durch enter *)
VAR     i, h: CARDINAL;
	rand, rest, neu: string;
BEGIN
test ( x <= MaxSpalten +1 , "ZeileEinfuegen");
Kuerzen; Auffuellen;  (* h>=x-1 <= MaxSpalten *)
rest:="";   rand :="";
i := Randbreite();  (*  i <= x-1 *)
Slice ( rand, s, 0  , i );
Slice ( rest, s, x-1, MaxSpalten );
Concat ( neu,rand, rest);
s[x-1]:= 0C;
Einfuegen (p, neu );  ZeileVor;
x:= min ( x, Randbreite() +1 );    SeiteAusgeben;
END  ZeileEinfuegen;





PROCEDURE    ScrollenVor;
(*      +-------------+      +----------------+   +------------------+
	!a            !      !b zeile         !   !c    zeile        !
	!b zeile      !      !c               !   !                  !
	!c            !      !                !   !                  !
	+-------------+      +----------------+   +------------------+  *)
VAR  t:  pzeile;
BEGIN
Abspeichern ;
IF      y> 1         THEN  DEC(y)
ELSIF   p^.n <> NIL  THEN   p:= p^.n; INC(z)  END;
Laden;
END     ScrollenVor;






PROCEDURE    ScrollenZurueck;
(*      +-------------+      +----------------+   +------------------+
	!a            !      !                !   !                  !
	!b zeile      !      !a               !   !                  !
	!c            !      !b  zeile        !   !a  zeile          !
	+-------------+      +----------------+   +------------------+  *)
VAR  t:  pzeile;
BEGIN
Abspeichern ; t:= top();  IF   t^.v = NIL    THEN  RETURN  END;
IF      y< WindowZeilen     THEN  INC(y)
ELSE    p:= p^.v; DEC(z)  END;
Laden;
END     ScrollenZurueck;




PROCEDURE    SeiteZurueck;
VAR   j: CARDINAL;
BEGIN
Abspeichern ;
FOR j:=1  TO WindowZeilen
	DO  IF z > y  THEN   p:= p^.v;  DEC(z) END;
END;
Laden;
END          SeiteZurueck;




PROCEDURE    SeiteVor;
VAR   j: CARDINAL;
BEGIN
Abspeichern ;
FOR  j:=1 TO WindowZeilen  DO
	IF p^.n <> NIL  THEN   p:= p^.n;  INC(z)  END;
END;
Laden;
END          SeiteVor;



PROCEDURE    ZumZeilenanfang;
BEGIN        x:= min (x, Randbreite()+1 );
END          ZumZeilenanfang;


PROCEDURE    ZeileLoeschen;
BEGIN
Loeschen(p); Laden; SeiteAusgeben;
END          ZeileLoeschen;


PROCEDURE    ZumZeilenende;
BEGIN   x:=  min(Spalten+1, Length (s)+1 ) ;  END  ZumZeilenende;



PROCEDURE    ZumTextanfang;
BEGIN
Abspeichern ;
p:= anfang; z:=1; y:=1;
Laden ;
END          ZumTextanfang;



PROCEDURE    ZumTextende;
BEGIN        Abspeichern ;
WHILE ( p^.n <> NIL ) DO  p:=p^.n; INC(z);  END;
Laden;
END          ZumTextende;



PROCEDURE    CursorUp;
BEGIN   IF p^.v  =  NIL  THEN RETURN END; ZeileZurueck;
END          CursorUp;



PROCEDURE    CursorDown;
BEGIN   IF p^.n  =  NIL  THEN RETURN END; ZeileVor;
END          CursorDown;


PROCEDURE    CursorLeft;
BEGIN   decx;   END     CursorLeft;



PROCEDURE    CursorRight;
BEGIN   IF x < MaxSpalten THEN INC(x) END;  END     CursorRight;



PROCEDURE    AlphanumVor;
VAR     h: CARDINAL;
BEGIN   h:= Length ( s);
WHILE   (x <= h)  AND     ( s[x-1] IN  alphanumerisch ) DO  INC(x) END;
WHILE   (x <= h)  AND  NOT( s[x-1] IN  alphanumerisch ) DO  INC(x) END;
END     AlphanumVor;





PROCEDURE    WortNachRechts;
VAR     h: CARDINAL;
BEGIN
test ( x> 0, "WortNachRechts: x>0");
h:= Length( s);  AlphanumVor;
IF      x<= h   THEN RETURN  END;
Abspeichern ;
WHILE   (p^.n <> NIL )  AND ( x > h ) DO
	incp; Laden; x:=1;  h:= Length( s);
	IF      s[0] IN  alphanumerisch  THEN RETURN END;
	AlphanumVor;
END; (* WHILE *)
END     WortNachRechts;


PROCEDURE AlphanumZurueck ;
BEGIN
IF      x < 1   THEN    RETURN  END;
(* 1 <= x <= h *)
WHILE ( x>= 1)  AND   NOT ( s[x-1] IN alphanumerisch ) DO DEC(x) END;
WHILE ( x>= 1)  AND       ( s[x-1] IN alphanumerisch ) DO DEC(x) END;
(* x wurde vermindert *)
IF      s[x]  IN alphanumerisch   THEN INC(x)  END;
END          AlphanumZurueck ;








PROCEDURE    WortNachLinks;  (* an den anfang des vorhergehenden wortes *)
VAR     h: CARDINAL;
BEGIN   h:= Length ( s);  IF  x> h  THEN  x:= h END;
(*0<=x <= h  *)
WHILE   (x>= 1 )  AND  (s[x-1] IN  alphanumerisch )   DO DEC(x)   END;
IF      x >= 1 THEN  AlphanumZurueck   END;
IF      x >= 1  THEN RETURN  END;
Abspeichern ;
WHILE    x <  1   DO
	IF      p^.v =  NIL   THEN  x:=1;  RETURN   END;
	decp; Laden; x := Length(s);
	AlphanumZurueck ;
END;    (* WHILE *)
END          WortNachLinks;



PROCEDURE    Help;
BEGIN        (*  wird in der naechsten ausgabe vorgestellt *)
END          Help;


PROCEDURE    Suchen;
BEGIN        (*  wird in der naechsten ausgabe vorgestellt *)
END          Suchen;


PROCEDURE    Aendern;
BEGIN        (*  wird in der naechsten ausgabe vorgestellt *)
END          Aendern;


PROCEDURE    WeiterSuchen;
BEGIN        (*  wird in der naechsten ausgabe vorgestellt *)
END  WeiterSuchen;

PROCEDURE    WeiterAendern;
BEGIN        (*  wird in der naechsten ausgabe vorgestellt *)
END  WeiterAendern;


PROCEDURE    SpaltenAendern;
BEGIN        IF  ( x > 1  ) AND (x < MaxSpalten ) THEN  Spalten :=  x;
	     ELSE   piepsen (3);     END;
END          SpaltenAendern;





PROCEDURE    BlockDefinieren ( VAR a,b : position );
VAR  i  : CARDINAL;
BEGIN   (* modus : block definieren,Optionen ausgeben   *)
PositionMerken ( a );   b:= a;
WHILE   NOT (   (befehl = ESC )   OR  keys("YC")    )  DO
	IF      befehl IN CursorVeraendern  THEN
		BefehlAusfuehren (befehl, key );
		PositionMerken (b );
		BlockSeiteAusgeben (a,b);
	ELSE    piepsen (12);  END;
	RdCom( befehl, key );
END;
END     BlockDefinieren;





PROCEDURE   BlockEinfuegen;
BEGIN       Splitten(p,x);  Laden;
            TextEinfuegen(p,ablage);
END         BlockEinfuegen;



PROCEDURE    Blockoperation;
VAR
a,b     : position;
i       : CARDINAL;
BEGIN   RdCom ( befehl, key );
IF      keys("CY")   THEN
	CASE    Capital (key)     OF
		'C'     :  BlockEinfuegen;
	|       'Y'     :  TextLoeschen ( ablage );
	END;
ELSE
	BlockDefinieren (a, b);
	IF      befehl = ESC    THEN  SeiteAusgeben;  RETURN END;
	CASE    Capital (key)      OF
		'Y'     :  BlockLoeschen (a,b);
	|       'C'     :  BlockAblegen ( a,b) ;
	END;
END;
SeiteAusgeben;
END     Blockoperation;





PROCEDURE    BlockLoeschen ( VAR a,b: position );
BEGIN
(* die obere Marke mu aktiviert werden ! *)
PositionenSortieren (a,b ); PositionAktivieren (b);
IF      (a.p = b.p )     THEN
        PositionAktivieren(a);
	Delete (s, a.x -1, b.x -a.x +1 ); Abspeichern ; RETURN;
END;
Delete (s, 0, b.x );  Speichern(p,s); (* ggf. mit abschliessenden blanks*)
PositionAktivieren (a);
Delete (s, a.x-1, MaxSpalten  ); Speichern (p,s);
IF      a.p^.n <>  b.p    THEN  ZeilenLoeschen ( a.p^.n, b.p^.v ) END;
Verketten (p); Laden; (* sonst wird p^.q^ durch s ueberschrieben ! *)
END     BlockLoeschen;



PROCEDURE    BlockAblegen  ( a,b: position );
VAR     s: string;
	x,t: pzeile;
BEGIN   s:="";
PositionenSortieren (a,b ); TextLoeschen (ablage );
IF      (a.p = b.p )     THEN
	Slice ( s, a.p^.q^, a.x -1,  b.x-a.x+1 );
	Erzeugen (ablage, s );   RETURN;
END;
s:="";Slice ( s, a.p^.q^, a.x-1, MaxSpalten   );
Erzeugen (ablage, s);  x := ablage; t := a.p^.n;
WHILE   Storage.Available (10000) AND   (t <> b.p )  DO
	Einfuegen (x, t^.q^);  t:=t^.n;  x:=x^.n;
END;
s:=""; Slice ( s, b.p^.q^, 0 , b.x     );
Einfuegen (x, s );
END     BlockAblegen;









PROCEDURE    BlanksEinstreuen ( q: pstring )  ;
VAR     i,i0,j,k,FehlendeBlanks: CARDINAL;
        t                      : pzeile;
        temp                   : zeile;
BEGIN
t := ADR(temp);  t^.q := q; t^.h := Length (q^);
IF  t^.h>= Spalten  THEN RETURN END;
CountBlanks(t,0,i); CountNotBlanks(t,i,j); INC(i,j); i0:= i;
CountBlanks(t,i,j);
IF      i+j >= t^.h   THEN RETURN END;  (* nur ein wort in der zeile *)
FehlendeBlanks := Spalten - t^.h;
FOR  k:=1    TO  FehlendeBlanks DO
	Insert(q^, " ", i);  INC(t^.h);
	CountBlanks(t,i,j);  INC(i,j);
	CountNotBlanks(t,i,j ); INC(i,j);
	CountBlanks(t,i,j);  	IF      i +j >= t^.h   THEN   i:= i0  END;
END;
END          BlanksEinstreuen;










PROCEDURE    Blocksatz ( anzeigen:  BOOLEAN );
VAR     i,j, w, r, Laenge          : CARDINAL;
	pv , a ,b                  : pzeile;
	neu                        : string;


PROCEDURE    WortVorhanden (  VAR i: CARDINAL; VAR w: CARDINAL):
		BOOLEAN;
BEGIN
IF      i>= p^.h  THEN  (* p ist abgearbeitet *)
	Loeschen (p); Laden; CountBlanks(p,0,i );
	IF     i =  p^.h     THEN RETURN (FALSE ); END;
END;
CountNotBlanks(p,i,w ); test ( w > 0 , "WortVorhanden");
INC(w);
IF      r + w > Spalten    THEN
	(*DAS wort IST ZULANG: DER BLOCKSATZ WIRD ABGEBROCHEN, DER
	ABGEARBEITETE TEIL VON p WIRD GELOESCHT*)
	Slice(s,s,i,MaxSpalten); Abspeichern; piepsen(4); RETURN (FALSE);
END;
RETURN (TRUE );
END          WortVorhanden;



BEGIN   (*Blocksatz*)
IF      x > Spalten        THEN  piepsen(3); RETURN ;  END;
Auffuellen;
CountBlanks(p,0,r);
IF      r >= p^.h   THEN  RETURN END;
CountNotBlanks(p,r,w);  INC(w);
IF      r+w > Spalten  THEN piepsen(2); RETURN;  END;
	(* bereits das erste "wort" ist zu lang *)
Move  (ADR(leerzeile),ADR(neu), r);   Laenge :=r; neu[Laenge]:=0C;
Erzeugen (a,neu); b :=a ; i:=r; (* i ist offset des eines nichtblanks *)
WHILE   WortVorhanden (i,w ) = TRUE  DO
	IF      Laenge+w > Spalten   THEN
		(* neu hat keinen platz mehr, ist also fertig *)
		neu[Laenge]:= 0C;
		IF  befehl = F8 THEN BlanksEinstreuen (ADR(neu))  END;
		Speichern (b, neu);
		Move (ADR(leerzeile),ADR(neu), r );
		Laenge :=r; neu[Laenge]:=0C;
		Einfuegen (b, neu);  b:= b^.n;
	END;
	Move(ADR( p^.q^[i]) , ADR(neu[Laenge]) , w);
	INC (Laenge,w); neu[Laenge-1] := ' ';
	CountBlanks(p,i+w,j ); INC(i,w+j);
	(* diese j blanks werden eliminiert *)
END;
neu[Laenge]:=0C; Speichern (b, neu );
TextLinken (p^.v, a);  p:=a; (*  y,z sind unverndert !!!! *)
Laden;
IF  anzeigen   THEN    SeiteAusgeben END;
END          Blocksatz;



BEGIN
alphanumerisch  := befehlszeichen{'a'..'z','A'..'Z','0'..'9'};

END  eduserop.

