MODULE TCAL;
FROM IO       IMPORT WrStr, RdCard, WrLn, WrCard, WrChar, WrCharRep;
FROM Calendar IMPORT tDate, eDateMode, eWeekday,
                     CardToDate, DateToCard, Weekday, DaysInMonth;

TYPE
  Names = ARRAY [1..12], [0..2] OF CHAR;

CONST
  MonthNames = Names('Jan','Feb','Mr','Apr','Mai','Jun',
                     'Jul','Aug','Sep','Okt','Nov','Dez');

VAR
  month, year, day,
  daysInMonth      : CARDINAL;
  date             : tDate;
  wd               : eWeekday;
  bool             : BOOLEAN;
  i, j, z          : CARDINAL;

BEGIN
  REPEAT
    WrStr('Bitte Monat geben: '); month := RdCard();
    WrStr('Bitte Jahr geben: ');  year := RdCard();
    bool := CardToDate(year, month, 1, short, date);
    IF NOT bool THEN
      WrStr('FALSCH, geht so nicht !!!'); WrLn;
    END;
  UNTIL bool;
  DateToCard (date, year, month, day);
  WrLn;
  WrChar(''); WrCharRep('',22); WrChar(''); WrLn;
  WrChar(''); WrCharRep(' ',7);
  WrStr (MonthNames[month]); WrCard(year,5);
  WrCharRep(' ', 7); WrChar(''); WrLn;
  WrChar(''); WrCharRep('',22); WrChar(''); WrLn;
  WrStr (' Mo Di Mi Do Fr Sa So '); WrLn;
  WrChar('');
  Weekday(date,wd);
  FOR i:= 1 TO ORD(wd) DO
    WrStr('   ');
  END;
  z := 1;
  FOR i:=ORD(wd) TO 6 DO
    WrCard(z,3); INC(z);
  END;
  bool := DaysInMonth (year, month, daysInMonth);
  WrStr(' '); WrLn; WrChar('');
  REPEAT
    WrCard(z, 3); INC(z);
    IF ((z+ORD(wd)-1) MOD 7 = 0) AND (z <= daysInMonth) THEN
      WrStr(' '); WrLn(); WrChar('');
    END;
  UNTIL z > daysInMonth;
  WHILE (z+ORD(wd)-1) MOD 7 # 0 DO
    WrStr('   '); INC(z);
  END;
  WrStr(' '); WrLn; WrChar(''); WrCharRep('',22); WrChar(''); WrLn;
END TCAL.
