MODULE TXNormal;
FROM Graph  IMPORT GraphMode, TextMode, Width, Depth,
                   Line, HLine, NumColor, Disc;
FROM XGraph IMPORT tCardType, AutoInit, InitNormalGraph, SetClipIndi,
                   SetDevView, ClearScreen, PlotStr;
FROM IO     IMPORT RdKey, WrStr;
VAR  ch : CHAR;
(*---------------------------------------------------------------------------*)
PROCEDURE Plots();
VAR i, col : CARDINAL;
    ch     : CHAR;
BEGIN
  FOR i := 0 TO 50 DO
    col := (i+1) MOD (NumColor-1) + 1;
    HLine (10+5*i, 10+i, Width-10-5*i, col);
    Line  (Width-10-5*i, 10+i, Width-10-i, Depth-10-i, col);
    HLine (10+i, Depth-10-i, Width-10-i, col);
    Line  (10+i, Depth-10-i, 10+5*i, 10+i, col);
  END;
  PlotStr (Width DIV 2 - 88, Depth DIV 2, 'Any key to continue...', col);
END Plots;
(*---------------------------------------------------------------------------*)
BEGIN
  IF AutoInit() = notFound THEN
    WrStr('No Graphic Card found !!!');
    HALT();
  END;
  GraphMode;
  (*-----*)
  PlotStr (Width DIV 2 - 56, Depth DIV 2 + 10, 'Original Graph', 1);
  Plots;
  ch := RdKey(); ClearScreen();
  (*-----*)
  InitNormalGraph;
  PlotStr (Width DIV 2 - 48, Depth DIV 2 + 10,
          'Normal Graph', 1);
  Plots;
  ch := RdKey(); ClearScreen();
  (*-----*)
  PlotStr (Width DIV 2 - 128, Depth DIV 2 + 10,
          'Clip at 70, 30, Width - 50, Depth - 40', 1);
  SetDevView (70, 30, Width - 50, Depth - 40);
  SetClipIndi (TRUE);
  Plots;
  ch := RdKey(); ClearScreen();
  (*-----*)
  PlotStr (Width DIV 2 - 116, Depth DIV 2 + 10,
          'Same Device Viewport, Clipping off', 1);
  SetClipIndi (FALSE);
  Plots;
  ch := RdKey(); ClearScreen();
  (*-----*)
  PlotStr (Width DIV 2 - 112, Depth DIV 2 + 10,
          'Three Viewports, Clipping on', 1);
  SetClipIndi (TRUE);
  SetDevView (70, 80, Width - 50, Depth - 10);
  Plots;
  SetDevView (Width DIV 2, 30, Width - 80, Depth DIV 2);
  Plots;
  SetDevView (Width-130, 10, Width - 30 , 90);
  Disc (Width-70, 70, 50, 1);
  ch := RdKey();
  (*-----*)
  TextMode;
END TXNormal.
