IMPLEMENTATION  MODULE  edfind;

TYPE

VAR
taste           :  ARRAY[0..1] OF  CHAR;
befehl          :  befehle;
key             :  CHAR;
alphanumerisch  :  befehlszeichen;


VAR    (* variablen fuer den dialog *)
x0,y0,z0,linkerrand0,Spalten0:  CARDINAL;
p0              : pzeile;
b               : befehle;
Dialogbefehle:befehlsmenge;
Optionen,Optionen0: ARRAY [0..80] OF CHAR;
OK,NurSuchen    : BOOLEAN;
PROCEDURE       fragedialog ( VAR  ergebnis:  BOOLEAN); FORWARD;
PROCEDURE       helpdialog;                             FORWARD;
PROCEDURE       OpenWindow  (             i:  CARDINAL);FORWARD;
PROCEDURE       dialogstarten                          ;FORWARD;
PROCEDURE       dialogbeenden                          ;FORWARD;
PROCEDURE       dialogschritt ( m: ARRAY OF CHAR      );FORWARD;
PROCEDURE       aktivieren  ( p: pzeile;  i:  CARDINAL);FORWARD;
PROCEDURE       deaktivieren ( p: pzeile              );FORWARD;
PROCEDURE       wassuchen                              ;FORWARD;
PROCEDURE       wieersetzen                            ;FORWARD;
PROCEDURE       welcheoptionen                         ;FORWARD;





PROCEDURE    capkey ():  CHAR;
VAR c: CHAR;
BEGIN  c:= key; Str.Caps(c); RETURN c  ;  END capkey;




PROCEDURE     fragedialog( VAR status:  BOOLEAN );
BEGIN
dialogstarten; wassuchen; dialogbeenden ; status:= OK;
END     fragedialog;



PROCEDURE     helpdialog;
BEGIN         (* NUR PROVISORISCH IMPLEMENTIERT *)
dialogstarten;
aktivieren (p,0); Window.SetWrap(TRUE);
Window.GotoXY (1,1);
IO.WrStr( " Hier koennen die kontextabhaengigen Fehlermeldungen");
IO.WrStr( " ausgegeben werden. Eine allegemeine Lsung des Helpproblems");
IO.WrStr( " knnte so aussehen: Die Helptexte werden in Dateien");
IO.WrStr( " abgespeichert und in eine neue Liste eingelesen.");
IO.WrStr( " Der Editior wird dann mit dieser Liste und eingeschrnkten");
IO.WrStr( " aktiven Befehlen aufgerufen. Drckt der User ESC,");
IO.WrStr( " wird diese Liste wieder gelscht.");
Window.SetWrap(FALSE);
WHILE  befehl <> ESC   DO RdCom(befehl, key ); END;
deaktivieren (p);
dialogbeenden  ;
END     helpdialog;






PROCEDURE     OpenWindow( zeilengesamt : CARDINAL );
VAR
d : Window.WinDef;
w : Window.WinType;
Fore,Back:  Window.Color;
BEGIN
w:= Window.Top(); Window.Info (w,d);

Window.SetFrame (w, Window.SingleFrame,d.FrameFore, d.FrameBack);
Window.Info ( w, d);


INC(d.X1); INC(d.Y1); INC(d.X2);
IF      zeilengesamt > 0   THEN  d.Y2 := d.Y1 + zeilengesamt -1 ;
ELSE    INC (d.Y2);  END;
d.FrameDef := Window.DoubleFrame;

w := Window.Open (d);

END     OpenWindow;







PROCEDURE  dialogstarten;
VAR
BEGIN

ZeilenumbruchOn := FALSE;
OK            := FALSE;
x0 := x; y0 := y;  z0:= z; p0:=p;  Spalten0 := Spalten;
linkerrand0 := linkerrand;  speichern (p,s);
Dialogbefehle := befehlsmenge{
	NOCOM, INS,
	LEFT,RIGHT, ControlLEFT,ControlRIGHT,HOME,ENDKEY,
	DEL,BACKSPACE} ;  (* ControlY *)
NurSuchen := ( befehl = F5 );
END        dialogstarten;





PROCEDURE  dialogbeenden  ;
VAR
BEGIN
x:=x0; y:=y0;  z:= z0; p:=p0;  Spalten := Spalten0;
linkerrand := linkerrand0;  laden;
Window.GotoXY(x-linkerrand,y+1);
END        dialogbeenden  ;







PROCEDURE     dialogschritt(  hinweis  : ARRAY OF CHAR);
VAR  i,j,m :  CARDINAL;
BEGIN;
hinweisausgeben (hinweis);
ScreenTox; quickshow; Window.GotoXY(x-linkerrand, y +1 );
RdCom ( befehl, key );
taste[0]:=key;
IF      befehl <> F1  THEN  Fehlerkontext :=  0;  END;
IF      befehl IN Dialogbefehle   THEN
	IF     (befehl = NOCOM)   THEN
	        Str.Caps(taste);
	        i:= Str.Pos(Optionen,taste);
	        m := MAX(CARDINAL);
		IF     (Length (Optionen ) = 0) OR
		 (( i < m ) AND  NOT ( taste[0] IN FindOptions ))
		THEN    befehlausfuehren (befehl,key);
		ELSE    piepsen(2)   END;
	ELSE    befehlausfuehren (befehl,key);  END;
END;
speichern (p, s);
END     dialogschritt;







PROCEDURE  aktivieren(px: pzeile;  zeilengesamt: CARDINAL );
VAR
BEGIN
x:=1 ; y:=1 ;  z:= 1;  p:=px; linkerrand := 0;  Spalten := 80;
Move ( px^.q, ADR(s), px^.h+1 );
Optionen0 := Optionen; (*  die optionen muessen vor dem aktivieren
gesetzt werden *)
END        aktivieren     ;




PROCEDURE  deaktivieren(px: pzeile );
VAR     w :  Window.WinType; d: Window.WinDef;
BEGIN
speichern (px, s);
w:= Window.Top(); Window.Close(w);
w:= Window.Top(); Window.Info (w, d );
Window.SetFrame ( w, Window.DoubleFrame, d.FrameFore, d.FrameBack );
Optionen := Optionen0;
END        deaktivieren     ;





PROCEDURE  wassuchen;
VAR
BEGIN
OpenWindow(4); aktivieren (pwas,4); Optionen :="";
REPEAT  dialogschritt ( "Was Suchen ? ");
	IF      befehl =  ENTER   THEN
		IF  NurSuchen   THEN  welcheoptionen; ELSE wieersetzen END;
		aktivieren (pwas,4 ); (* das window wurde bereits gerettet*)
	END;
UNTIL   (befehl = ESC)  OR  ( OK =  TRUE );
deaktivieren (pwas);
END     wassuchen;




PROCEDURE  wieersetzen;
VAR
BEGIN
OpenWindow(4); aktivieren (pwie,4);
REPEAT  dialogschritt ( "Wie Ersetzen  ? ");
	IF      befehl =  ENTER   THEN
		welcheoptionen; aktivieren (pwie,4) ;
	END;
UNTIL   (befehl = ESC)  OR  ( OK =  TRUE );
IF    befehl = ESC  THEN  befehl := UNDEFINED  END;
deaktivieren(pwie);
END     wieersetzen;








PROCEDURE  welcheoptionen;
VAR  i:  CARDINAL;
BEGIN
OpenWindow(4);  aktivieren (popt, 4);
Optionen := "GWU";
FindOptions := zeichen{};
REPEAT  dialogschritt
	( "Optionen: {G}esamt, {W}ort, Gross/Kleinschr. nicht {u}nterscheiden" );
	IF  befehl =   ENTER   THEN OK:=TRUE END;
	IF (befehl =   NOCOM )  THEN
	    Str.Caps(taste); i:=Str.Pos (Optionen, taste);
	    IF   i= 1  THEN  INCL(FindOptions,'G'); END;
	    IF   i= 2  THEN  INCL(FindOptions,'W'); END;
	    IF   i= 3  THEN  INCL(FindOptions,'U'); END;
	END;
UNTIL   (befehl = ESC)  OR ( OK = TRUE );
IF befehl = ESC  THEN   befehl := UNDEFINED END;
deaktivieren (popt);
END     welcheoptionen;


BEGIN
alphanumerisch  := befehlszeichen{'a'..'z','A'..'Z','0'..'9'};

END  edfind.
