IMPLEMENTATION          MODULE  edtools0   ;



PROCEDURE    piepsen(HelptextNummer:  CARDINAL);
BEGIN        Fehlerkontext := HelptextNummer;
             IO.WrStr(CHAR(7));
	     (* "PRESS ENTER FOR HELP"  *)
END  piepsen;



PROCEDURE    fehler ( meldung: ARRAY OF  CHAR );
BEGIN        Window.GotoXY(1,WindowZeilen +1);
IO.WrStr("FEHLER: "); IO.WrStr(meldung); HALT;
END          fehler;


PROCEDURE    min(a,b:CARDINAL ): CARDINAL;
BEGIN
IF   a<= b  THEN RETURN a ; ELSE RETURN b  END;
END          min   ;


PROCEDURE    max(a,b:CARDINAL ): CARDINAL;
BEGIN
IF   a<= b  THEN RETURN b ; ELSE RETURN a  END;
END          max   ;



PROCEDURE    Capital (c: CHAR ): CHAR;
VAR          s: ARRAY[0..1] OF CHAR;
BEGIN        s:=""; s[0]:=c; Str.Caps(s); RETURN s[0];
END          Capital   ;





PROCEDURE       test ( bedingung: BOOLEAN ; meldung: ARRAY OF CHAR );
BEGIN   IF      bedingung = FALSE  THEN  fehler(meldung)  END;
END             test;


PROCEDURE       CountBlanks ( p:pzeile; i:CARDINAL; VAR j: CARDINAL );
VAR   k:   CARDINAL;
BEGIN           (*  i >= ist der offset in p^.q^. *)
IF   i>= p^.h   THEN  j:= 0; RETURN; END ;
k:= p^.h-i ;         (*  p^.q^[i+j] = p^.q^[p^.h] = 0C;   *)
j:= Lib.ScanNeR ( ADR(p^.q^[i]), k, SHORTCARD(' ') );
(* ScanNeR betrachtet die byte p^.q^[i+j] fr j = i,..,i+k-1 und  gibt
den ersten offset j mit p^.q^[i+j] <> ' ' zurueck oder k *)
END             CountBlanks;




PROCEDURE       CountNotBlanks ( p:pzeile; i:CARDINAL; VAR j: CARDINAL );
VAR   k:   CARDINAL;
BEGIN           (*  i >= ist der offset in p^.q^. *)
IF   i>= p^.h   THEN  j:= 0; RETURN; END ;
k:= p^.h-i ; (*  p^.q^[i+j] = p^.q[p^.h] = 0C;   *)
j:= Lib.ScanR ( ADR(p^.q^[i]), k, SHORTCARD(' ') );
(* ScanR betrachtet die byte p^.q^[i+j] fr j= i,..,i+k-1 und gibt den ersten
offset j mit p^.q^[i+j] = ' ' zurueck oder k *)
END             CountNotBlanks;




PROCEDURE       LCountBlanks ( p:pzeile; i:CARDINAL; VAR j: CARDINAL );
VAR   k:   CARDINAL;
BEGIN           (*  i >= ist der offset in p^.q^. *)
IF   i>= p^.h   THEN  j:= 0; RETURN; END ;
j:= Lib.ScanNeL ( ADR(p^.q^[i]), i+1, SHORTCARD(' ') );
(* j ist der offset des ersten Nichtblanks, also die anzahl der blanks ab i *)
END             LCountBlanks;



PROCEDURE       LCountNotBlanks ( p:pzeile; i:CARDINAL; VAR j: CARDINAL );
VAR   k:   CARDINAL;
BEGIN           (*  i >= ist der offset in p^.q^. *)
IF   i>= p^.h   THEN  j:= 0; RETURN; END ;
j:= Lib.ScanL ( ADR(p^.q^[i]), i+1, SHORTCARD(' ') );
(* j ist er offset des ersten blanks bzw i+1, also die anzahl der blanks ab i *)
END             LCountNotBlanks;




PROCEDURE    nextblank (p: pstring;  i: CARDINAL;  VAR j:   CARDINAL );
VAR
BEGIN        j:= i ;
IF        p^[j] = 0C   THEN   RETURN END;
WHILE   ( p^[j] <> 0C)  AND ( p^[j] <> ' ' )  DO INC (j);  END;
END          nextblank;



PROCEDURE    skipblanks (  p: pstring; i: CARDINAL;   VAR j:   CARDINAL );
BEGIN        j:= i ;
WHILE   ( p^[j] = ' ' )  DO INC (j);  END;
END          skipblanks;



END     edtools0   .





