MODULE TXString;
FROM Graph  IMPORT GraphMode, TextMode, Width, Depth,
                   Line, HLine, NumColor;
FROM XGraph IMPORT tCardType,
                   AutoInit, InitNormalGraph, ClearScreen, SetClipIndi,
                   PlotStr, SetCharHeight, SetCharExpan,
                   SetCharSpace, SetCharUp;
FROM IO     IMPORT RdKey, WrStr;
VAR ch : CHAR;
    card : tCardType;
    col : CARDINAL;
(*--------------------------------------------------------------------*)
PROCEDURE Plots();
BEGIN
  col := 2;
  PlotStr (0, Depth - 80, 'Defaults', col);
  SetCharHeight(2.2);
  PlotStr (140, Depth - 80, 'CharHeight : 2.2', col);
  SetCharHeight(2.8);
  PlotStr (140, Depth - 110, 'CharHeight : 2.8', col);
  SetCharHeight(2.0);
  SetCharExpan (2.3);
  PlotStr (10, Depth - 130, 'CharExpan : 2.3', col+1);
  SetCharExpan (0.5);
  PlotStr (10, Depth - 150, 'CharExpan : 0.5', col+1);
  SetCharHeight(1.0);
  SetCharExpan (0.5);
  PlotStr (10, Depth - 160, 'CharExpan : 0.5', col+1);
  SetCharExpan (1.0);
  SetCharSpace (1.0);
  PlotStr (10, Depth - 170, 'CharSpace : 1.0', col+2);
  SetCharSpace (2.0);
  PlotStr (10, Depth - 180, 'CharSpace : 2.0', col+2);
  SetCharHeight (2.0);
  PlotStr (10, Depth - 200, 'CharSpace : 2.0', col+2);
  SetCharUp (-1.0, 0.0);
  SetCharSpace(0.0);
  PlotStr (20, 0, 'Up -1,0', col+3);
  SetCharUp (-1.0, 2.0);
  SetCharHeight(2.0);
  PlotStr (100, 0, 'Up -1,2', col+3);
  SetCharUp (0.5, 2.0);
  SetCharSpace(2.0);
  SetCharExpan(0.5);
  PlotStr (100, 100, 'Up 0.5,2', col+3);
  SetCharHeight (1.0);
  SetCharExpan (1.0);
  SetCharSpace (0.0);
  SetCharUp (0.0, 1.0);
  PlotStr (Width - 177, 0, 'Any Key To Continue...', col);
END Plots;
BEGIN
  card := AutoInit();
  IF card = notFound THEN
    WrStr('No Graphic Card found !!!');
    HALT();
  END;
  col := 3;
  InitNormalGraph;
  GraphMode;
  PlotStr (Width DIV 2 - 80, Depth - 22, 'ͻ', col);
  PlotStr (Width DIV 2 - 80, Depth - 30, ' Font Demo ', col);
  PlotStr (Width DIV 2 - 80, Depth - 38, 'ͼ', col);
  Plots();
  ch := RdKey();
  ClearScreen();
  TextMode;
END TXString.
